<?php
/*
+---------------------------------------------------------------+
|	e107 website system Gallery2.1 Plugin
|	functions.php
|
|	Garbor and Rashan 2006 update to Gallery2.1
|	(garbor@gmx.net, rashan@hagan-net.net)
|
|     Latest updates by Rik (2007)
|     http://www.e107.be
|     rik@e107.be
|
|
|	Released under the terms and conditions of the
|	GNU General Public License (http://gnu.org).
+---------------------------------------------------------------+
*/
// require_once(e_BASE."class2.php");

//////////////////////////////////////////
// Load the localized text
//////////////////////////////////////////
@include_once(e_PLUGIN.'gallery2/languages/'.e_LANGUAGE.'/'.e_LANGUAGE.'.php');
@include_once(e_PLUGIN.'gallery2/languages/English/English.php');

//////////////////////////////////////////
// Load configured values from db
//////////////////////////////////////////
function g2_LoadConfig()
{
  global $PLUGINS_DIRECTORY, $g2EmbedUri, $g2Uri, $g2Path, $g2Loginredirect, $g2Displaysidebar, $g2Displaylogin, $g2Userint;
  
  $g2EmbedUri = e_HTTP.$PLUGINS_DIRECTORY.'gallery2/gallery2.php';

  $sql = new db;
  $sql -> db_Select("gallery2Plugin", "g2Uri, path, loginredirect, displaysidebar, displaylogin, userint", "", false);
  list($g2Uri, $g2Path, $g2Loginredirect, $g2Displaysidebar, $g2Displaylogin, $g2Userint) = $sql-> db_Fetch();
  
/* For debuging
  echo "g2_LoadConfig()<BR>";
  echo "g2EmbedUri: ".$g2EmbedUri."<BR>";
  echo "g2Uri: ".$g2Uri."<BR>";
  echo "g2Path: ".$g2Path."<BR>";
  echo "g2Loginredirect: ".$g2Loginredirect."<BR>";
*/
}

//////////////////////////////////////////
// Initialize gallery2 embedding
//////////////////////////////////////////
// 'fullInit' => (optional) call GalleryInitSecondPass (only use when not calling handleRequest) 
function g2_Init($fullInit = false)
{
  global $g2EmbedUri, $g2Uri, $g2Path, $g2Loginredirect, $g2Userint, $activeuser, $gallery;
 
  require_once($g2Path . 'embed.php'); 

  // allways use active user or guest as login
  $activeuser = ($g2Userint == 0 || USERID == 'USERID') ? "" : USERID;
  
  // this plugin is build on API Version 1.1
  // ERROR_PLUGIN_VERSION_MISMATCH is returned if your integration is not compatible
  $g2ApiVersion = array(1, 1);
  
  $ret = GalleryEmbed::init(array( 
    'g2Uri' => $g2Uri, 
    'embedUri' => $g2EmbedUri,
    'apiVersion' => $g2ApiVersion,
    'fullInit' => $fullInit,
    'loginRedirect' => $g2Loginredirect , 
    'activeUserId' => $activeuser)); 

  // check if the right database is selected 
  g2_CheckDb();
 
  return $ret;
}

//////////////////////////////////////////
// Tell gallery we are done and reconnect to e107 database
//////////////////////////////////////////
function g2_Close()
{
  // Tell gallery we are done
  GalleryEmbed::done();
  // Reconnect to the e107 database for following db queries;
  e107_ConnectDb();
}

//////////////////////////////////////////
// Update or create a gallery2 user
//////////////////////////////////////////
function g2_ChangeOrCreateUser($userid, $g2user)
{  
/* For debuging
  echo "g2_ChangeOrCreateUser()<BR>";
  echo "userid: ".$userid."<BR>";
  echo "g2user: "; 
  print_r($g2user);
  echo "<BR>";
*/
  ////////////////////////////////////////
  // Check if the e107 user is mapped to a gallery user
  $ret = GalleryEmbed::isExternalIdMapped( $userid, 'GalleryUser' );

  ////////////////////////////////////////
  // Create User if the user not exists
  if ($ret && ($ret->getErrorCode() & ERROR_MISSING_OBJECT) > 0)
  {
    $ret = GalleryEmbed::createUser($userid, $g2user); 
    if ($ret) { 
        if (($ret->getErrorCode() & ERROR_COLLISION) > 0)
          $error = G2_LAN_ERROR_USER_EXISTS;
        else
          $error = G2_LAN_ERROR_CREATE_USER."<BR/>".$ret->getAsHtml(); 
    } 
    // TODO: we have to handle errors elsewhere
  } 
  ////////////////////////////////////////
  // Update User if allready present
  else if (!$ret)
  {
    $ret = GalleryEmbed::updateUser($userid, $g2user);
    if ($ret) { 
      if (($ret->getErrorCode() & ERROR_MISSING_OBJECT) > 0)
        $error = G2_LAN_ERROR_MAPPING;
      else
        $error = G2_LAN_ERROR_UPDATE_USER."<BR/>".$ret->getAsHtml(); 
    }
  }
  else
  {
    $error .= $ret->getAsHtml(); 
  }
  return $error;
}

//////////////////////////////////////////
// Load the e107 user data into a g2user array
//////////////////////////////////////////
function e107_LoadUserData($where)
{
  $sql = new db;
  $sql->db_Select("user", "user_id, user_loginname, user_name, user_email", $where, true);
  list($userid, $loginname, $username, $useremail) = $sql->db_Fetch();
  $g2user = array(
      'username' => $loginname, 
      'email' => $useremail, 
      'fullname' => $username);
  return array ($userid, $g2user);
}

//////////////////////////////////////////
// Reconnect to the e107 database
//////////////////////////////////////////
function e107_ConnectDb()
{
  global $mySQLserver, $mySQLuser, $mySQLpassword, $mySQLdefaultdb, $sql;
  if (!is_a($sql, 'db')) {
    $sql = new db;
  }
  $sql -> db_Connect($mySQLserver, $mySQLuser, $mySQLpassword, $mySQLdefaultdb);
}

//////////////////////////////////////////
// check if the right database is selected 
// (work around for the ERROR_STORAGE_FAILURE)
//////////////////////////////////////////
function g2_CheckDb()
{
  global $gallery;
  if ($gallery && $storage = $gallery->getStorage())
  {
    $db_configured  = $storage->_database;
    if ($db_configured && isset($storage->_db))
    {
      $record = $storage->_db->Execute('SELECT DATABASE()');
      if ($record)
        list($db_selected) = $record->FetchRow();
        if ($db_configured != $db_selected)
          $storage->_db->SelectDB($db_configured);
    }
  }
}  
?>
